/*
	 prg ICE_DEP.C construit le fichier donnees pour ICE.EXE
	 05.06.1991
*/
#include "stdio.h"
#include "time.h"
#include "dos.h"

int an,ms,jr,hh,mm,ss,tz;
int mois[12] = {31,28,31,30,31,30,31,31,30,31,30,31};

main(argc,argv)
int argc;
char *argv[];
{
   FILE *fpin,*fpout;
   int i;
   char date[9],time[9];
   char str1[6][80],str2[80],str[80],nomf[20],*pch[6];
   double ftps,fhms;
   struct date datec;
   struct time timec;

   if(strlen(argv[1]) == 0)
   {
      strcpy(nomf,"ice.DFT");
      fpin = fopen("ICE.DFT","r");
   }
   else
   {
      strcpy(nomf,argv[1]);
      fpin = fopen(argv[1],"r");
   }
   if(fpin == 0)
   {
      printf("\n  Pas de fichier .dft\n\n");
      exit(0);
   }

   /* lecture fichier .dft */
   for(i=0;i<6;i++)
   {
      pch[i] = &str1[i][0];
      fgets(pch[i],80,fpin);
   }
   sscanf(pch[5],"%*s%*s%*s%d",&tz);
   fclose(fpin);

   fpout = fopen("ICE.DFT","w");

   getdate(&datec);
   jr = datec.da_day;
   ms = datec.da_mon;
   an = datec.da_year;

   gettime(&timec);

   hh = timec.ti_hour;
   mm = timec.ti_min;
   ss = timec.ti_sec;
   ajust_tz();

   ftps = ((double) an) * 10000. + ((double) ms) * 100. + (double) jr;
   fhms = (double) hh + ((double) mm)/100. +((double) ss)/10000.;
   ftps = ftps + fhms / 100.;

   strncpy(str2,pch[0],18);
   str2[18] = '\0';
   sprintf(pch[0],"%18s%.6lf\n",str2,ftps);
   for(i=0;i<6;i++)
      fprintf(fpout,"%s",pch[i]);
   fclose(fpin);
   fclose(fpout);
   execl("ice.EXE",NULL);
}

ajust_tz()
{
   hh -= tz;
   if(hh <0)
   {
      hh += 24;
      jr--;
      if(jr<0)
      {
         if(ms > 1)
         {
            ms--;
            jr = mois[ms-1];
            if(ms == 2 && (an % 4) == 0) jr++;
         }
         else
         {
            ms = 12;
            jr = 31;
            an--;
         }
      }
   }
   else
   {
      if(hh < 24) return;
      hh -= 24;
      jr++;
      if(ms == 2 && (an % 4)==0 && jr == 30)
      {
         ms++;
         jr = 1;
         return;
      }
      if(ms == 12 && jr == 32)
      {
         ms = 1;
         an++;
         jr = 1;
         return;
      }
      if(jr <= mois[ms-1]) return;
      jr = 1;
      ms++;
   }
}